var itemsLeft;
var itemsTop;
var itemAutoOpen;
var itemList;
var itemsList;
var lastRequest = new Date(2019, 1, 1);
chrome.runtime.onInstalled.addListener(obj => {
    if (manifestData.whid == "TRIO") {
        if (obj.reason == "install") {
            var url = "https://kendoemailapp.com/welcome";
            chrome.tabs.create({ url: url }, tab => { });
        }
    }
    else {
        chrome.tabs.create({ url: "https://www.linkedin.com" }, tab => { });
    }
});
chrome.tabs.onUpdated.addListener((tabId, info) => {
    chrome.tabs.get(tabId, tab => {
        const scrpt = `meentroToolbar?meentroToolbar(${itemsLeft},${itemsTop},${itemAutoOpen},'${JSON.stringify(cfg)}','${itemList ? itemList : ""}','${itemsList ? itemsList : ""}'):null`;
        chrome.tabs.executeScript(tabId, { code: scrpt }, res => { });
    });
});
chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
    if (message.openURL) {
        chrome.windows.create({ type: "normal", url: message.openURL, height: 600, width: 800 }, win => {
            var tm = 0;
            var si = setInterval(() => {
                try {
                    tm++;
                    if (tm < 12)
                        chrome.tabs.executeScript(win.tabs[0].id, { code: `strtPopupGoPre()` }, () => { });
                }
                catch (error) { }
            }, 1000);
            setTimeout(() => {
                clearInterval(si);
                chrome.tabs.executeScript(win.tabs[0].id, { code: `strtPopupGo()` }, () => { });
            }, 12000);
        });
    }
    else if (message.showURL) {
        chrome.tabs.create({ url: message.showURL });
    }
    else if (message.gmail) {
        chrome.windows.create({
            url: "https://mail.google.com/mail/?ui=2&view=cm&fs=1&tf=1&shva=1&to=" +
                message.gmail,
            width: 850,
            height: 670,
            focused: true,
            type: "popup"
        });
    }
    else if (message.autoopen != undefined) {
        chrome.storage.sync.get(undefined, items => {
            items.itemAutoOpen = message.autoopen;
            itemAutoOpen = message.autoopen;
            chrome.storage.sync.set(items);
        });
    }
    else if (message.itemlist != undefined) {
        chrome.storage.sync.get(undefined, items => {
            items.itemList = message.itemlist;
            itemList = message.itemlist;
            chrome.storage.sync.set(items);
        });
    }
    else if (message.itemslist != undefined) {
        chrome.storage.sync.get(undefined, items => {
            items.itemsList = message.itemslist;
            itemsList = message.itemslist;
            chrome.storage.sync.set(items);
        });
    }
    else if (message.ajax) {
        const oReq = new XMLHttpRequest();
        oReq.onreadystatechange = function () {
            if (this.readyState == 4 && this.status == 200) {
                var x = JSON.parse(this.responseText);
                if (x.requestprofile) {
                    lastRequest = new Date();
                    sendResponse(x);
                }
                else
                    sendResponse(x);
            }
            if (this.readyState == 4 && this.status != 200) {
                sendResponse(undefined);
            }
        };
        if (message.type == "GET") {
            var diff = Math.abs(new Date().getTime() - lastRequest.getTime());
            var resultInMinutes = Math.round(diff / 60000);
            message.ajax = message.ajax + `&__tokent=${new Date().getTime()}&trx=${resultInMinutes}`;
        }
        oReq.open(message.type, message.ajax, true);
        if (message.t)
            oReq.timeout = message.t;
        if (message.data) {
            if (typeof message.data === "string" || message.data instanceof String)
                oReq.send(message.data);
            else {
                oReq.setRequestHeader("Content-type", "application/json; charset=utf-8");
                oReq.send(JSON.stringify(message.data));
            }
        }
        else
            oReq.send();
        return true; // Will respond asynchronously.
    }
    else {
        chrome.storage.sync.get(undefined, items => {
            items.left = message.left;
            items.top = message.top;
            itemsLeft = message.left;
            itemsTop = message.top;
            chrome.storage.sync.set(items);
        });
    }
});
function getRandomToken() {
    const randomPool = new Uint8Array(32);
    crypto.getRandomValues(randomPool);
    var hex = "";
    for (var i = 0; i < randomPool.length; ++i) {
        hex += randomPool[i].toString(16);
    }
    return hex;
}
const manifestData = chrome.runtime.getManifest();
if (manifestData.whid == "TRIO") {
    chrome.runtime.setUninstallURL("http://kendoemailapp.com/uninstall");
}
const cfg = {
    widgetBackground: manifestData.widgetBackground,
    widgetIcon: manifestData.widgetIcon,
    widgetRootURL: manifestData.widgetRootURL,
    widgetHelpURL: manifestData.widgetHelpURL,
    googleLogin: manifestData.googleLogin,
    widgetDashboardUrl: manifestData.widgetDashboardUrl,
    widgetVersion: manifestData.version,
    widgetInvertButton: manifestData.widgetInvertButton,
    widgetSpinner: manifestData.widgetSpinner,
    widgetBtnDownloadContact: manifestData.widgetBtnDownloadContact,
    widgetBtnHelp: manifestData.widgetBtnHelp,
    widgetBtnGmail: manifestData.widgetBtnGmail,
    widgetWelcomeMsg: manifestData.widgetWelcomeMsg,
    widgetBatchEmail: manifestData.widgetBatchEmail,
    widgetHeight: manifestData.widgetHeight,
    widgetNameCSS: manifestData.widgetNameCSS,
    widgetButtonCSS: manifestData.widgetButtonCSS,
    whid: uuidv4(),
    txtmemberMail1: uuidv2("a"),
    txtmemberMail2: uuidv2("b"),
    txtmemberPhone1: uuidv2("c"),
    txtmemberPhone2: uuidv2("d"),
    txtmemberTwit: uuidv2("e"),
    txtmemberWebsite: uuidv2("f"),
    txtmemberCallToAction: uuidv2("h"),
    txtmemberStatus: uuidv2("i"),
    txtmemberEmail: uuidv2("i"),
    whid2: manifestData.whid,
    disclaimer: manifestData.disclaimer
};
chrome.storage.sync.get(undefined, items => {
    itemsTop = items.itemsTop;
    itemAutoOpen = items.itemAutoOpen;
    itemList = items.itemList;
    itemsList = items.itemsList;
    cfg.ID = items.ID;
    if (!cfg.ID) {
        cfg.ID = getRandomToken();
        chrome.storage.sync.set({ ID: cfg.ID }, () => { });
    }
});
function uuidv4() {
    return "ember-xxxxx-xxxxx".replace(/[xy]/g, function (c) {
        const r = (Math.random() * 16) | 0, v = c == "x" ? r : (r & 0x3) | 0x8;
        return v.toString(16);
    });
}
function uuidv2(str) {
    return (str + "xxxxxxxxxxxx".replace(/[xy]/g, function (c) { const r = (Math.random() * 16) | 0, v = c == "x" ? r : (r & 0x3) | 0x8; return v.toString(16); }));
}
//# sourceMappingURL=action.js.map